/* rexx script to implement roaming access (bookamrks only) via FTP */
/* requires rxftp, works with any netscape                             */
/* this script downloads the localbookmark file from the ftp server         */

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

signal on syntax name norxftp
call RxFuncAdd 'FtpLoadFuncs','rxFtp','FtpLoadFuncs'
call FtpLoadFuncs
signal off syntax

call syscls
say ''
say ''
say 'PMRA (Poor Mans Roaming Access) .041 (OS/2)'
say 'Freeware, Copyright (C) 2002, Michael W. Cocke <cocke@catherders.com>'
say ''

parse arg cfgfile
if cfgfile = "" then do
   say "Missing parameter- drive:\path\filename.ext of config file."
   say 'Press any key to continue'
   pull dummy
   signal AllDone
end /* do */

rc = SysFileTree(cfgfile,exist,'F')
if exist.0<1 then do
   say 'No such config file: 'cfgfile
   say 'Press any key to continue'
   pull dummy
   signal AllDone
end /* do */

N = 0
do while lines(cfgfile)>0
        tst = linein(cfgfile)
         if left(tst,1)<>"#" then do
             Settings.N=tst
             N=N+1
         end /* if do */
end /* do while */
N=N-1

if N<>7 then do
   say 'Invalid config file - please read docs!'
   say 'Press any key to continue'
   pull dummy
   signal AllDone
end /* do */

/* settings.0 = ftp site */
/* settings.1 = userid   */
/* settings.2 = password */
/* settings.3 = localdir */
/* settings.4 = remote dir */
/* settings.5 = local filename */
/* settings.6 = remote filename */
/* settings.7 = browser command */

/*  do O = 0 to N  */
/*     say settings.O  */
/*  end  */  

say 'Download Phase...'

rc = ftpping(settings.0,'56')
if datatype(rc)='CHAR' then do
   say 'Cannot ping 'settings.0' successfully - terminating'
   say 'Press any key to continue'
   pull dummy
   signal AllDone
   end /* do */

rc = FtpSetUser(settings.0,settings.1,settings.2)
if rc=1 then say settings.1 'successfully logged on to 'settings.0
else do
     say 'logon to 'settings.0 'failed - terminating...'
     say 'Press any key to continue'
     pull dummy
     signal AllDone
end /* do */

if right(settings.3,1)<>"\" then LocalBookMark=settings.3'\'settings.5
else
LocalBookmark = settings.3''settings.5

RemoteBookmark=settings.4''settings.6
DOwnloadOk=1
rc = FtpGet(localbookmark,remotebookmark,"Binary")
if rc = 0 then 
        say localbookmark 'downloaded successfully.'
   else do
        DownloadOk=0
        say 'Download failure - using 'localbookmark' (if any)'
        say 'Press any key to continue'
        pull dummy
   end /* do */

/* now run the browser.  We could do this in parts, unlike the windows version */
/* but what the heck */
say 'Run the browser (synchronous)'
settings.7

/* I've just discovered that on a fast computer, the relatively slow warpzilla 1.x */
/* browsers may not be finished rewriting and flushing the bookmark file.        */
/* we need to brute-force a delay in here so changes have time to be written before we grab the file */
say 'Awaiting final rewrite and flush of bookmark file...'
call syssleep 30

say 'Upload Phase...'

If DownloadOk=0 then do
     say 'Previous download failed - do upload (Y/N)? '
     parse upper pull dummy
     if Dummy <>'Y' then signal AllDone
end /* do */

rc = ftpping(settings.0,'56')
if datatype(rc)='CHAR' then do
   say 'Cannot ping 'settings.0' successfully - terminating'
   say 'Press any key to continue'
   pull dummy
   signal AllDone
   end /* do */

rc = FtpSetUser(settings.0,settings.1,settings.2)
if rc=1 then say settings.1 'successfully logged on to 'settings.0
else do
     say 'logon to 'settings.0 'failed - terminating...'
     say 'Press any key to continue'
     pull dummy
     signal AllDone
end /* do */

rc = FtpPut(localbookmark,remotebookmark,"Binary")
if rc = 0 then 
        say localbookmark 'uploaded successfully.'
   else do
        say 'Upload Failure!!!'
        say 'Press any key to continue'
        pull dummy
   end /* do */

AllDone:
rc=ftplogoff()
rc=ftpdropfuncs()
exit

norxftp:
say 'cannot locate rxftp.dll'
say 'Press any key to continue'
pull dummy
exit

